(function() {
  var client, fatal_error_handler, show_error_handler;
  client = (require('./chat-client')).connect();
  fatal_error_handler = function(error) {
    console.error('fatal:', error.toString());
    client.close();
    return process.exit(1);
  };
  show_error_handler = function(error) {
    return console.error('error:', error.toString());
  };
  client.on('server-error', show_error_handler);
  client.on('protocol-error', fatal_error_handler);
  client.on('client-error', fatal_error_handler);
  client.on('join', function(channel, who) {
    return console.log("[" + channel + "] * " + who + " joined");
  });
  client.on('part', function(channel, who, why) {
    return console.log("[" + channel + "] * " + who + " parted (" + why + ")");
  });
  client.on('say', function(channel, who, what) {
    return console.log("[" + channel + "] <" + who + "> " + what);
  });
  client.on('nick', function(channel, old_nick, new_nick) {
    return console.log("[" + channel + "] * " + old_nick + " is now known as " + new_nick);
  });
  process.stdin.setEncoding('utf8');
  process.stdin.resume();
  process.stdin.on('data', function(chunk) {
    var channel, line, lines, match, what, _i, _len, _ref, _results;
    lines = chunk.split('\n');
    _results = [];
    for (_i = 0, _len = lines.length; _i < _len; _i++) {
      line = lines[_i];
      line = line.trim();
      if (line.length === 0) {
        continue;
      }
      _results.push(line.match(/^\/list\s*/i) ? client.list(function(list) {
        return console.log(list);
      }) : (match = line.match(/^\/nick\s+(\S+)/i)) ? client.nick(match[1]) : (match = line.match(/^\/join\s+(\S+)/i)) ? client.join(match[1]) : (match = line.match(/^\/part\s+(\S+)/i)) ? client.part(match[1]) : (match = line.match(/^\/members\s+(\S+)/i)) ? (channel = match[1], client.members(match[1], function(nicks) {
        return console.log("" + channel + ": " + nicks);
      })) : (match = line.match(/^\/say\s+(\S+)\s+(.+)/i)) ? ((_ref = [match[1], match[2]], channel = _ref[0], what = _ref[1], _ref), client.say(channel, what)) : (match = line.match(/^\/info\s*/i)) ? client.info(function(info) {
        return console.log(info);
      }) : console.log("unknown command"));
    }
    return _results;
  });
  process.stdin.on('end', function() {
    console.debug('QUITTING');
    return client.close();
  });
}).call(this);
